package com.xmomen.module.base.entity;

import com.xmomen.framework.mybatis.model.BaseMybatisExample;
import java.util.ArrayList;
import java.util.List;

// 优惠券分类实体类
public class CdCouponCategoryExample extends BaseMybatisExample {
    // 排序字段
    protected String orderByClause;

    // 是否去重
    protected boolean distinct;

    // 查询条件
    protected List<Criteria> oredCriteria;

    // 构造函数
    public CdCouponCategoryExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    // 设置排序字段
    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    // 获取排序字段
    public String getOrderByClause() {
        return orderByClause;
    }

    // 设置是否去重
    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    // 获取是否去重
    public boolean isDistinct() {
        return distinct;
    }

    // 获取查询条件
    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    // 添加查询条件
    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    // 创建查询条件
    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    // 创建查询条件
    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    // 创建查询条件
    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    // 清空查询条件
    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    // 生成查询条件
    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        // 判断查询条件是否有效
        public boolean isValid() {
            return criteria.size() > 0;
        }

        // 获取所有查询条件
        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        // 获取查询条件
        public List<Criterion> getCriteria() {
            return criteria;
        }

        // 添加查询条件
        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        // 添加查询条件
        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        // 添加查询条件
        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        // 添加ID为空的查询条件
        public Criteria andIdIsNull() {
            addCriterion("ID is null");
            return (Criteria) this;
        }

        // 添加ID不为空的查询条件
        public Criteria andIdIsNotNull() {
            addCriterion("ID is not null");
            return (Criteria) this;
        }

        // 添加ID等于指定值的查询条件
        public Criteria andIdEqualTo(Integer value) {
            addCriterion("ID =", value, "id");
            return (Criteria) this;
        }

        // 添加ID不等于指定值的查询条件
        public Criteria andIdNotEqualTo(Integer value) {
            addCriterion("ID <>", value, "id");
            return (Criteria) this;
        }

        // 添加ID大于指定值的查询条件
        public Criteria andIdGreaterThan(Integer value) {
            addCriterion("ID >", value, "id");
            return (Criteria) this;
        }

        // 添加ID大于等于指定值的查询条件
        public Criteria andIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("ID >=", value, "id");
            return (Criteria) this;
        }

        // 添加ID小于指定值的查询条件
        public Criteria andIdLessThan(Integer value) {
            addCriterion("ID <", value, "id");
            return (Criteria) this;
        }

        // 添加ID小于等于指定值的查询条件
        public Criteria andIdLessThanOrEqualTo(Integer value) {
            addCriterion("ID <=", value, "id");
            return (Criteria) this;
        }

        // 添加ID在指定值范围内的查询条件
        public Criteria andIdIn(List<Integer> values) {
            addCriterion("ID in", values, "id");
            return (Criteria) this;
        }

        // 添加ID不在指定值范围内的查询条件
        public Criteria andIdNotIn(List<Integer> values) {
            addCriterion("ID not in", values, "id");
            return (Criteria) this;
        }

        // 添加ID在指定值范围内的查询条件
        public Criteria andIdBetween(Integer value1, Integer value2) {
            addCriterion("ID between", value1, value2, "id");
            return (Criteria) this;
        }

        // 添加ID不在指定值范围内的查询条件
        public Criteria andIdNotBetween(Integer value1, Integer value2) {
            addCriterion("ID not between", value1, value2, "id");
            return (Criteria) this;
        }

        // 添加分类类型为空的查询条件
        public Criteria andCategoryTypeIsNull() {
            addCriterion("CATEGORY_TYPE is null");
            return (Criteria) this;
        }

        // 添加分类类型不为空的查询条件
        public Criteria andCategoryTypeIsNotNull() {
            addCriterion("CATEGORY_TYPE is not null");
            return (Criteria) this;
        }

        // 添加分类类型等于指定值的查询条件
        public Criteria andCategoryTypeEqualTo(Integer value) {
            addCriterion("CATEGORY_TYPE =", value, "categoryType");
            return (Criteria) this;
        }

        // 添加分类类型不等于指定值的查询条件
        public Criteria andCategoryTypeNotEqualTo(Integer value) {
            addCriterion("CATEGORY_TYPE <>", value, "categoryType");
            return (Criteria) this;
        }

        // 添加分类类型大于指定值的查询条件
        public Criteria andCategoryTypeGreaterThan(Integer value) {
            addCriterion("CATEGORY_TYPE >", value, "categoryType");
            return (Criteria) this;
        }

        // 添加分类类型大于等于指定值的查询条件
        public Criteria andCategoryTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("CATEGORY_TYPE >=", value, "categoryType");
            return (Criteria) this;
        }

        // 添加分类类型小于指定值的查询条件
        public Criteria andCategoryTypeLessThan(Integer value) {
            addCriterion("CATEGORY_TYPE <", value, "categoryType");
            return (Criteria) this;
        }

        // 添加分类类型小于等于指定值的查询条件
        public Criteria andCategoryTypeLessThanOrEqualTo(Integer value) {
            addCriterion("CATEGORY_TYPE <=", value, "categoryType");
            return (Criteria) this;
        }

        // 添加分类类型在指定值范围内的查询条件
        public Criteria andCategoryTypeIn(List<Integer> values) {
            addCriterion("CATEGORY_TYPE in", values, "categoryType");
            return (Criteria) this;
        }

        // 添加分类类型不在指定值范围内的查询条件
        public Criteria andCategoryTypeNotIn(List<Integer> values) {
            addCriterion("CATEGORY_TYPE not in", values, "categoryType");
            return (Criteria) this;
        }

        // 添加分类类型在指定值范围内的查询条件
        public Criteria andCategoryTypeBetween(Integer value1, Integer value2) {
            addCriterion("CATEGORY_TYPE between", value1, value2, "categoryType");
            return (Criteria) this;
        }

        // 添加分类类型不在指定值范围内的查询条件
        public Criteria andCategoryTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("CATEGORY_TYPE not between", value1, value2, "categoryType");
            return (Criteria) this;
        }

        // 添加分类名称为空的查询条件
        public Criteria andCategoryNameIsNull() {
            addCriterion("CATEGORY_NAME is null");
            return (Criteria) this;
        }

        // 添加分类名称不为空的查询条件
        public Criteria andCategoryNameIsNotNull() {
            addCriterion("CATEGORY_NAME is not null");
            return (Criteria) this;
        }

        // 添加分类名称等于指定值的查询条件
        public Criteria andCategoryNameEqualTo(String value) {
            addCriterion("CATEGORY_NAME =", value, "categoryName");
            return (Criteria) this;
        }

        // 添加分类名称不等于指定值的查询条件
        public Criteria andCategoryNameNotEqualTo(String value) {
            addCriterion("CATEGORY_NAME <>", value, "categoryName");
            return (Criteria) this;
        }

        // 添加分类名称大于指定值的查询条件
        public Criteria andCategoryNameGreaterThan(String value) {
            addCriterion("CATEGORY_NAME >", value, "categoryName");
            return (Criteria) this;
        }

        // 添加分类名称大于等于指定值的查询条件
        public Criteria andCategoryNameGreaterThanOrEqualTo(String value) {
            addCriterion("CATEGORY_NAME >=", value, "categoryName");
            return (Criteria) this;
        }

        // 添加分类名称小于指定值的查询条件
        public Criteria andCategoryNameLessThan(String value) {
            addCriterion("CATEGORY_NAME <", value, "categoryName");
            return (Criteria) this;
        }

        // 添加分类名称小于等于指定值的查询条件
        public Criteria andCategoryNameLessThanOrEqualTo(String value) {
            addCriterion("CATEGORY_NAME <=", value, "categoryName");
            return (Criteria) this;
        }

        // 添加分类名称包含指定值的查询条件
        public Criteria andCategoryNameLike(String value) {
            addCriterion("CATEGORY_NAME like", value, "categoryName");
            return (Criteria) this;
        }

        // 添加分类名称不包含指定值的查询条件
        public Criteria andCategoryNameNotLike(String value) {
            addCriterion("CATEGORY_NAME not like", value, "categoryName");
            return (Criteria) this;
        }

        // 添加分类名称在指定值范围内的查询条件
        public Criteria andCategoryNameIn(List<String> values) {
            addCriterion("CATEGORY_NAME in", values, "categoryName");
            return (Criteria) this;
        }

        // 添加分类名称不在指定值范围内的查询条件
        public Criteria andCategoryNameNotIn(List<String> values) {
            addCriterion("CATEGORY_NAME not in", values, "categoryName");
            return (Criteria) this;
        }

        // 添加分类名称在指定值范围内的查询条件
        public Criteria andCategoryNameBetween(String value1, String value2) {
            addCriterion("CATEGORY_NAME between", value1, value2, "categoryName");
            return (Criteria) this;
        }

        // 添加分类名称不在指定值范围内的查询条件
        public Criteria andCategoryNameNotBetween(String value1, String value2) {
            addCriterion("CATEGORY_NAME not between", value1, value2, "categoryName");
            return (Criteria) this;
        }
    }

    // 生成查询条件
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    // 生成查询条件
    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        // 获取查询条件
        public String getCondition() {
            return condition;
        }

        // 获取查询条件的值
        public Object getValue() {
            return value;
        }

        // 获取查询条件的第二个值
        public Object getSecondValue() {
            return secondValue;
        }

        // 判断查询条件是否为空
        public boolean isNoValue() {
            return noValue;
        }

        // 判断查询条件是否为单个值
        public boolean isSingleValue() {
            return singleValue;
        }

        // 判断查询条件是否为范围值
        public boolean isBetweenValue() {
            return betweenValue;
        }

        // 判断查询条件是否为列表值
        public boolean isListValue() {
            return listValue;
        }

        // 获取查询条件的类型处理器
        public String getTypeHandler() {
            return typeHandler;
        }

        // 创建查询条件
        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        // 创建查询条件
        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        // 创建查询条件
        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        // 创建查询条件
        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        // 创建查询条件
        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}